// The following needs to be kept in sync with the .voting-countries & .voting-points widths in css/eurovision.css
var glob_voting_country_and_points_width = (180+35); 

function transpose_i(i,num_cols, num_rows)
{
    // Map 'i' to (x,y) position in grid layout
    var x = (i % num_cols);
    var y = Math.floor(i / num_cols); // affect int division
    
    // Transpose, and then reverse engineer what value of 'i' the transposed position needs to be
    var trans_x = y;
    var trans_y = x;
    
    var trans_i = trans_y * num_rows + trans_x;

    return trans_i;
}

function append_to_country_votes(vote_label, votes_json_type, votes_type_total)
{
    // TODO
    // Figure out why "United Kingdom-J" and not "UnitedKingdom-J"

    if (gs.documentMetadata[votes_json_type]) {
	var all_votes_div_width  = $('#to-country-votes').width();
	
	var $vote_label_div = $('<div>').attr("class","voting-label").append(vote_label);
	$vote_label_div.append(" (Total: " + gs.documentMetadata[votes_type_total] + ")");
	$('#to-country-votes').append($vote_label_div);

	var $vote_points_div = $('<div>').attr("class","voting-points-div");
	
	var VotesJSON = eval(gs.documentMetadata[votes_json_type]);
	var num_countries = VotesJSON.length;

	var num_cols = Math.floor(all_votes_div_width / glob_voting_country_and_points_width);
	var num_rows = Math.ceil(num_countries / num_cols);
	var num_cells = num_cols * num_rows;
	
	VotesJSON.sort();

	for (var i=0; i<num_cells; i++) {
	    var trans_i = transpose_i(i,num_cols, num_rows);

	    // By default, they country and points are set to be empty divs
	    var $to_country_name = $('<div>').attr("class","voting voting-country").append("");
	    var $to_country_points = $('<div>').attr("class","voting voting-points").append("");

	    // check to see if trans_i position is within array, otherwise default to filler
	    if (trans_i < num_countries) {
		var from_country  = VotesJSON[trans_i];
		var from_country_points = gs.documentMetadata[from_country];
		
		if (typeof from_country_points !== 'undefined') {
		    var pp_from_country = from_country.replace(/-(T|J)$/,"");
		    
		    $from_country_name = $('<div>').attr("class","voting voting-country").append(pp_from_country + ":");
		    $from_country_points = $('<div>').attr("class","voting voting-points").append(from_country_points);		    
		}
	    }
	    
	    $('#to-country-votes')
		.append($from_country_name)
		.append($from_country_points);
		
	}

	$('#to-country-votes').append($vote_points_div);

    }
}
	  

function compare_countries(a,b)
{
    if (a.Country < b.Country) {
	return -1;
    }
    if (a.Country > b.Country) {
	return 1;
    }

    // names must be equal
    return 0;
}

function compare_points(a,b)
{
    return a.Points - b.Points;
}

function append_from_country_votes(from_country_year_id,vote_type)
{
    if (vote_type != "") {
	var all_votes_div_width  = $('#from-country-votes').width();
	
	var votes_country_json_type = "VotesCountryJSON-" + vote_type;
	var votes_points_json_type = "VotesPointsJSON-" + vote_type;
	var vote_label = (vote_type == "J") ? "Jury votes" : "Televotes";
	
	var $vote_div = $('<div>').attr("class","voting-label").append(vote_label);
	$('#from-country-votes').append($vote_div);
	
	var VotesCountryJSON = eval(gs.documentMetadata[votes_country_json_type]); // map JSON string into data-structure
	var VotesPointsJSON = eval(gs.documentMetadata[votes_points_json_type]);   // map JSON string into data-structure

	var num_countries = VotesCountryJSON.length;
	
	var num_cols = Math.floor(all_votes_div_width / glob_voting_country_and_points_width);
	var num_rows = Math.ceil(num_countries / num_cols);
	var num_cells = num_cols * num_rows;
	
	var from_country_votes = [];
	
	for (var i=0; i<num_countries; i++) {
	    from_country_votes.push({ "Country" : VotesCountryJSON[i], "Points" : VotesPointsJSON[i]})
	}

	from_country_votes.sort(compare_countries);

	for (var i=0; i<num_cells; i++) {

	    var trans_i = transpose_i(i,num_cols, num_rows);

	    var $to_country_name = $('<div>').attr("class","voting voting-country").append("");
	    var $to_country_points = $('<div>').attr("class","voting voting-points").append("");

	    // check to see if trans_i position is within array, otherwise default to filler	    
	    if (trans_i < num_countries) {
		var to_country  = from_country_votes[trans_i].Country;
		var to_country_points = from_country_votes[trans_i].Points;
		
		if (typeof to_country_points !== 'undefined') {
		    
		    $to_country_name = $('<div>').attr("class","voting voting-country").append(to_country + ":");
		    $to_country_points = $('<div>').attr("class","voting voting-points").append(to_country_points);		    
		}
	    }
	    
	    $('#from-country-votes')
		.append($to_country_name)
		.append($to_country_points);

	}
    }
}
	  
