#!/bin/bash

prep_dir=voting-excel

if [ ! -d $prep_dir/my-python-env ] ; then
    echo "" 1>&2
    echo "Failed to find: $prep_dir/my-python-env" 1>&2
    echo "Have you run:" 1>&2
    echo "  cd $prep_dir && ./CREATE-PYTHON-VENV.sh && cd .." 1>&2
    echo "" 1>&2
    
    exit 1
fi

if [ ! -d "$prep_dir/metadata-votes" ] ; then
    echo "Creating directory:"
    echo "  $prep_dir/metadata-votes"
    
    mkdir "$prep_dir/metadata-votes"
fi
exit_status=0


source  $prep_dir/my-python-env/bin/activate

$prep_dir/xlsx-fromcountry-jsonmetadata.py \
    --votingtype "J" \
    $prep_dir/eurovision_song_contest_1975_2019.xlsx  \
    $prep_dir/metadata-votes/metadata-votes-fromcountry-jury.json


if [ $? = 0 ] ; then
    $prep_dir/xlsx-fromcountry-jsonmetadata.py \
	--votingtype "T" \
	$prep_dir/eurovision_song_contest_1975_2019.xlsx  \
	$prep_dir/metadata-votes/metadata-votes-fromcountry-tele.json

    if [ $? = 0 ] ; then
	$prep_dir/xlsx-tocountry-jsonmetadata.py $prep_dir/eurovision_song_contest_1975_2019.xlsx  $prep_dir/metadata-votes-tocountry.json

	if [ $? != 0 ] ; then
	    echo "!!!!" 1>&2
	    echo "! Error enountered generating to-country metadata-json" 1>&2
	    echo "!!!!" 1>&2
	    exit_status=1
	fi
    else
	echo "!!!!" 1>&2
	echo "! Error enountered generating from-country Televoting metadata-json" 1>&2
	echo "!!!!" 1>&2
	exit_status=1
    fi
else
    echo "!!!!" 1>&2
    echo "! Error enountered generate from-country Jury metadata-json" 1>&2
    echo "!!!!" 1>&2
    exit_status=1
fi


deactivate

if [ $exit_status != 0 ] ; then
    exit $exit_status
fi
